ParaView
========

##An open-source, multi-platform data analysis and visualization application

Introduction
------------

**ParaView** is an open-source, multi-platform data analysis and visualization application. ParaView users can quickly build visualizations to analyze their data using qualitative and quantitative techniques. The data exploration can be done interactively in 3D or programmatically using ParaView's batch processing capabilities.

ParaView was developed to analyze extremely large datasets using distributed memory computing resources. It can be run on supercomputers to analyze datasets of exascale size as well as on laptops for smaller data.

Homepage : <http://www.paraview.org/>

Installed version
-----------------
Currently, version 4.0.1 compiled with GCC 4.8.1 against Bull MPI library and OSMesa 10.0 is installed on Anselm.

Usage
-----
On Anselm, ParaView is to be used in client-server mode. A parallel ParaView server is launched on compute nodes by the user, and client is launched on your desktop PC to control and view the visualization. Download ParaView client application for your OS here: <http://paraview.org/paraview/resources/software.php>. Important : **your version must match the version number installed on Anselm** ! (currently v4.0.1)

### Launching server

To launch the server, you must first allocate compute nodes, for example

```bash
    $ qsub -I -q qprod -A OPEN-0-0 -l select=2
```

to launch an interactive session on 2 nodes. Refer to [Resource Allocation and Job Execution](../resource-allocation-and-job-execution/introduction/) for details.

After the interactive session is opened, load the ParaView module :

```bash
    $ module add paraview
```

Now launch the parallel server, with number of nodes times 16 processes:

```bash
    $ mpirun -np 32 pvserver --use-offscreen-rendering
    Waiting for client...
    Connection URL: cs://cn77:11111
    Accepting connection(s): cn77:11111
```

Note the that the server is listening on compute node cn77 in this case, we shall use this information later.

### Client connection

Because a direct connection is not allowed to compute nodes on Anselm, you must establish a SSH tunnel to connect to the server. Choose a port number on your PC to be forwarded to ParaView server, for example 12345. If your PC is running Linux, use this command to estabilish a SSH tunnel:

```bash
    ssh -TN -L 12345:cn77:11111 username@anselm.it4i.cz
```

replace  username with your login and cn77 with the name of compute node your ParaView server is running on (see previous step). If you use PuTTY on Windows, load Anselm connection configuration, t>hen go to Connection-&gt; SSH>-&gt;Tunnels to set up the port forwarding. Click Remote radio button. Insert 12345 to Source port textbox. Insert cn77:11111. Click Add button, then Open.

Now launch ParaView client installed on your desktop PC. Select File-&gt;Connect..., click Add Server. Fill in the following :

Name : Anselm tunnel
Server Type : Client/Server
Host : localhost
Port : 12345

Click Configure, Save, the configuration is now saved for later use. Now click Connect to connect to the ParaView server. In your terminal where you have interactive session with ParaView server launched, you should see:

```bash
    Client connected.
```

You can now use Parallel ParaView.

### Close server

Remember to close the interactive session after you finish working with ParaView server, as it will remain launched even after your client is disconnected and will continue to consume resources.

GPU support
-----------
Currently, GPU acceleration is not supported in the server and ParaView will not take advantage of accelerated nodes on Anselm. Support for GPU acceleration might be added in the future.
